/*	
	streamripper-plugin 0.1		
	Copyright (C) 2008 by lokster 
	lokiisyourmaster@gmail.com
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or   
	(at your option) any later version.                                 
	                                                                    
	This program is distributed in the hope that it will be useful,     
	but WITHOUT ANY WARRANTY; without even the implied warranty of      
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
	GNU General Public License for more details.                        
	                                                                    
	You should have received a copy of the GNU General Public License   
	along with this program; if not, write to the                       
	Free Software Foundation, Inc.,                                     
	59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
*/   
#include "config.h"

#include <glib.h>
#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <signal.h>
#include <unistd.h>
#include <stdio.h>

#include <string.h>

#include <audacious/plugin.h>
#include <audacious/ui_preferences.h>
#include <audacious/auddrct.h>
#include <audacious/i18n.h>
#include <audacious/hook.h>
#include <audacious/ui_plugin_menu.h>
#include <audacious/playlist.h>

static void init(void);
static void cleanup(void);

GeneralPlugin sr_gp =
{
	.description = "StreamRipper " PACKAGE_VERSION,
	.init = init,
	.cleanup = cleanup,
};

GeneralPlugin *streamripper_gplist[] = { &sr_gp, NULL };
SIMPLE_GENERAL_PLUGIN(streamripper, streamripper_gplist);

static void cleanup(void)
{
	signal(SIGCHLD, SIG_DFL);
}

static void run_streamripper(void)
{

	char *argv[4] = {"/bin/sh", "-c", "xterm -e streamripper \"`audtool current-song-filename`\" -r -i -d ~", NULL};

	int i;

	if (fork() == 0)
	{
		for (i = 3; i < 255; i++)
			close(i);
		execv("/bin/sh", argv);
	}
}

static void run_streamripper1(void)
{

	char *argv[4] = {"/bin/sh", "-c", "xterm -e streamripper \"`audtool current-song-filename`\" -r -i -d ~", NULL};
	char *argv1[4] = {"/bin/sh", "-c", "audacious http://localhost:8000", NULL};

	int i;

	if (fork() == 0)
	{
		for (i = 3; i < 255; i++)
			close(i);
		execv("/bin/sh", argv);
	}
	
	if (fork() == 0)
	{
		for (i = 3; i < 255; i++)
			close(i);
		execv("/bin/sh", argv1);
	}
}

static void init(void)
{
	gchar *menu_item_text;
	static GtkWidget *main_menu_item;
	gchar *menu_item_text1;
	static GtkWidget *main_menu_item1;

	menu_item_text = _("Rip with streamripper");
	main_menu_item = gtk_image_menu_item_new_with_label(menu_item_text);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(main_menu_item), gtk_image_new_from_stock(GTK_STOCK_SAVE, GTK_ICON_SIZE_MENU));
	gtk_widget_show(main_menu_item);
	audacious_menu_plugin_item_add(AUDACIOUS_MENU_MAIN, main_menu_item);
	g_signal_connect(G_OBJECT(main_menu_item), "activate", G_CALLBACK(run_streamripper), NULL);
	
	menu_item_text1 = _("Rip with streamripper and play relay stream");
	main_menu_item1 = gtk_image_menu_item_new_with_label(menu_item_text1);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(main_menu_item1), gtk_image_new_from_stock(GTK_STOCK_SAVE, GTK_ICON_SIZE_MENU));
	gtk_widget_show(main_menu_item1);
	audacious_menu_plugin_item_add(AUDACIOUS_MENU_MAIN, main_menu_item1);
	g_signal_connect(G_OBJECT(main_menu_item1), "activate", G_CALLBACK(run_streamripper1), NULL);
}
